<?php
/*
  $Id: osc_iconv.php, v1.0 2007/01/15 $
  Author: Light Tseng
  http://www.ezeshop.com.tw/
  reference:
  big5_func.inc 0.22
*/
if(!function_exists("iconv")){

  class Big5FileCache {
      var $Big5Cache = array();
      function OpenFile($file_name)
      {
          $md5index = substr(md5($file_name),0,8);
          if ( @array_key_exists($md5index , $this->Big5Cache) )
          {
              return $md5index;
          }	
          else
          {
              $fp =  @fopen($file_name,"rb");
              if($fp)
              {
                  $this->Big5Cache[$md5index]->fp   = $fp;
                  $this->Big5Cache[$md5index]->size = filesize($file_name);
                  $this->Big5Cache[$md5index]->isCache   = false;;
                  return $md5index;
              }
              else return false;
          }
      }
      function &ReadFile($fp , $unserialize=false)
      {
      	
          if ( @array_key_exists($fp , $this->Big5Cache) && $this->Big5Cache[$fp]->isCache )
          {
              if($unserialize)
                  return $this->Big5Cache[$fp]->usdata;
              else
                  return $this->Big5Cache[$fp]->data;
          }
          else
          {
  
              $this->Big5Cache[$fp]->data = @fread( $this->Big5Cache[$fp]->fp ,  $this->Big5Cache[$fp]->size );
              $this->Big5Cache[$fp]->isCache = true;
              if($unserialize)
              {
              	$this->Big5Cache[$fp]->usdata = unserialize($this->Big5Cache[$fp]->data);
                  return $this->Big5Cache[$fp]->usdata;
              }
              else
                  return $this->Big5Cache[$fp]->data;
          }
      }
  }
  
  define("BIG5_FILE_DIR" , dirname(__FILE__) );
  define("BIG5_UNICODE_START" , 0xa140);
  $Big5FileCacheObj =new Big5FileCache();
  
  function big5_isBig5($c="")
  {
    $bc  = hexdec(bin2hex($c));
    if
    (
       ($bc>=0xa440 && $bc<= 0xc67e) ||
       ($bc>=0xc940 && $bc<= 0xf9fe) ||
       ($bc>=0xa140 && $bc<= 0xa3fe) ||
       ($bc>=0xc6a1 && $bc<= 0xc8fe)
    ) return true;
    return false;
  }
  
  function big5_utf8_encode($str)
  {
      global $Big5FileCacheObj;
      $fp = $Big5FileCacheObj->OpenFile(BIG5_FILE_DIR  ."/big5_utf8.tab");
      if($fp)
          $tab = & $Big5FileCacheObj->ReadFile($fp);
  
      else
      {
          $error_handler = set_error_handler("Big5ErrorHandler");
          trigger_error ("big5_utf8_encode() : Can not open file '" . BIG5_FILE_DIR . "/big5_utf8.tab'", E_USER_ERROR );
          restore_error_handler();
      }
  
  
      $len = strlen($str);
  
      for($i=0; $i< $len; $i++)
      {
        if(big5_isBig5( $str[$i].$str[$i+1] ))
        {
            $a1 = Ord(substr($str,$i,1));
            $a2 = Ord(substr($str,$i+1,1));
            $ret_str .= substr($tab,($a1*256 + $a2 - BIG5_UNICODE_START)*3,3);
            $i++;
        }
        else 
            $ret_str .= utf8_encode($str[$i]);
      }  
      return $ret_str;
  }
  
  function big5_utf8_decode($str)
  {
      global $Big5FileCacheObj;
      $fp = $Big5FileCacheObj->OpenFile(BIG5_FILE_DIR  ."/utf8_big5.tab");
      if($fp)
      {
          $tab = &$Big5FileCacheObj->ReadFile($fp,true);
  
      }
      else
      {
          $error_handler = set_error_handler("Big5ErrorHandler");
          trigger_error ("big5_utf8_decode() : Can not open file '" . BIG5_FILE_DIR . "/utf8_big5.tab'", E_USER_ERROR );
          restore_error_handler();
      }
  
      $len = strlen($str);
      for($i=0 ; $i<$len ; $i++)
      {
      	$check = Ord($str[$i]);
          if( $check >> 7 == 0)
              $ret_str .= chr($check);
  
          else if ( $check>>5 == 6 ) // AscII > 127 SŸ
          {
              $ret_str .= $tab[bin2hex($str[$i].$str[$i+1])];
              $i++;
          }
          else if ( $check>> 4 == 0xe)
          {
               $ret_str .= $tab[bin2hex($str[$i].$str[$i+1].$str[$i+2])];
              $i+=2;
          }
  
      }
     return $ret_str;
  }

  function big52gb($Text) {
    $fp = fopen(BIG5_FILE_DIR."/big5_gb.tab", "r");
    $max = strlen($Text) - 1;
    for ($i = 0;$i < $max;$i++) {
    	$h = ord($Text[$i]);
    	if ($h >= 160) {
    		$l = ord($Text[$i + 1]);
    		if ($h == 161 && $l == 64) {
    			$gb = " ";
    		} else {
    			fseek($fp, ($h - 160)*510 + ($l - 1)*2);
    			$gb = fread($fp, 2);
    		}
    		$Text[$i] = $gb[0];
    		$Text[$i + 1] = $gb[1];
    		$i++;
    	}
    }
    fclose($fp);
    return $Text;
  }

  function gb2big5($Text) {
    $fp = fopen(BIG5_FILE_DIR."/gb_big5.tab", "r");
    $max = strlen($Text) - 1;
    for ($i = 0;$i < $max;$i++) {
    $h = ord($Text[$i]);
    if ($h >= 160) {
    $l = ord($Text[$i + 1]);
    if ($h == 161 && $l == 64) {
    		$gb = " ";
    	} else {
    fseek($fp, ($h - 160)*510 + ($l - 1)*2);
    	$gb = fread($fp, 2);
    		}
    $Text[$i] = $gb[0];
    $Text[$i + 1] = $gb[1];
    		$i++;
    	}
    }
    fclose($fp);
    return $Text;
  }

  function iconv($in_charset,$out_charset,$str) {
    if(strtolower($in_charset)=='big5' and (strtolower($out_charset)=='utf-8' or strtolower($out_charset)=='utf8')) 
      $str=big5_utf8_encode($str);
    if(strtolower($out_charset)=='big5' and (strtolower($in_charset)=='utf-8' or strtolower($in_charset)=='utf8')) 
      $str=big5_utf8_decode($str);
    if(strtolower($in_charset)=='gbk' and (strtolower($out_charset)=='utf-8' or strtolower($out_charset)=='utf8')) { 
      $str=gb2big5($str);
      $str=big5_utf8_encode($str);
    }
    if(strtolower($out_charset)=='gbk' and (strtolower($in_charset)=='utf-8' or strtolower($in_charset)=='utf8')) {
      $str=big5_utf8_decode($str);
      $str=big52gb($str);
    }
    return $str;
  }

}
?>